<?php

namespace Opentalent\OtAdmin\Command;


use Opentalent\OtAdmin\Controller\SiteController;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Style\SymfonyStyle;
use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Object\ObjectManager;

/**
 * This CLI command updates an existing organization's website
 * with the latest data from the Opentalent DB
 *
 * @package Opentalent\OtAdmin\Command
 */
class UpdateSiteCommand extends Command
{
    /**
     * -- This method is expected by Typo3, do not rename ou remove --
     *
     * Allows to configure the command.
     * Allows to add a description, a help text, and / or define arguments.
     *
     */
    protected function configure()
    {
        $this
            ->setName("ot:site:update")
            ->setDescription("Update an organization website")
            ->setHelp("This CLI command update an existing organization's website
                            with the latest data from the Opentalent DB")
            ->addOption(
                'all',
                null,
                InputOption::VALUE_NONE,
                "Update all of the organization websites"
            )
            ->addArgument(
                'organization-id',
                InputArgument::OPTIONAL,
                "The organization's id in the opentalent DB"
            )
            ->addOption(
                'deep',
                'd',
                InputOption::VALUE_NONE,
                "Performs a deep update (recreate the site config file, reset the be_users permissions)"
            );
    }

    /**
     * -- This method is expected by Typo3, do not rename ou remove --
     *
     * @param InputInterface $input
     * @param OutputInterface $output
     * @throws \Exception
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $org_id = $input->getArgument('organization-id');
        $all = $input->getOption('all');
        $deep = $input->getOption('deep');

        if ($all && $org_id) {
            throw new \InvalidArgumentException("You can not pass both an organization id and the --all option");
        }
        if (!$all && !$org_id) {
            throw new \InvalidArgumentException("You shall either pass an organization id or use the --all option");
        }

        $io = new SymfonyStyle($input, $output);

        $siteController = GeneralUtility::makeInstance(ObjectManager::class)->get(SiteController::class);

        $msg_deep = $deep ? 'deeply ' : '';

        if ($all) {
            $connectionPool = GeneralUtility::makeInstance(ConnectionPool::class);
            $queryBuilder = $connectionPool->getQueryBuilderForTable('pages');
            $sites = $queryBuilder
                ->select('tx_opentalent_structure_id')
                ->from('pages')
                ->where('is_siteroot=1')
                ->andWhere($queryBuilder->expr()->gt('tx_opentalent_structure_id', 0))
                ->execute()
                ->fetchAll();

            $io->progressStart(count($sites));

            foreach ($sites as $site) {
                $org_id = $site['tx_opentalent_structure_id'];
                try {
                    $siteController->updateSiteAction($org_id, $deep);
                } catch (\Throwable $e) {
                    $io->error('Organization Id: ' . $org_id . ' - ' . $e->getMessage());
                }
                $io->progressAdvance(1);
            }
            $io->progressFinish();

            $io->success(sprintf("The websites have all been " . $msg_deep . "updated"));
        } else {
            $rootUid = $siteController->updateSiteAction($org_id, $deep);
            $io->success(sprintf("The website with root uid " . $rootUid . " has been " . $msg_deep . "updated"));
        }
    }
}
